# Type Theoretic Gradual Typing

Gradually typed languages allow for the gradual addition of static
types to dynamically typed programs, helping one-off scripts, quick
prototypes and legacy codebases mature into robust, reasonable
programs. A key design principle is that this process be incremental:
statically typed programs must be allowed to interoperate with
dynamically typed programs or else entire codebases would have to be
re-written before using the typed programs. However, different gradual
languages and calculi disagree on the semantics of this
interoperability, specifically if and when any types are checked
dynamically at runtime.

We show that type theoretic βη reasoning principles, chiefly η,
distinguish between different dynamic type checking
schemes. Furthermore, when combined with the principle of graduality
(a gradual analogue of parametricity) we show that almost all of the
cast semantics can be derived from an equational theory. By using a
gradual type theory based on call-by-push-value as a metalanguage, we
can derive cast semantics for many different evaluation orders from
the same basic type theoretic principles.

# Bio

Max S. New is a PhD candidate in computer science at Northeastern
University. His PhD work focuses on semantic models and (in)equational
reasoning principles for gradually typed programming languages. More
broadly, he is interested in the use of type theory and category
theory to understand program semantics and language design.
